//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright   "2005-2014, MetaQuotes Software Corp."
#property link        "http://www.mql4.com"


input double TakeProfit    =50;
input double Lots          = 0.1;
input double TrailingStop  =30;
input double MACDOpenLevel =3;
input double MACDCloseLevel=2;
input int    MATrendPeriod =26;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick(void)
  {
 
//---
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
//---



string identity = WindowExpertName();
int  extract_number = StrToInteger(StringSubstr(identity,7,2));
int ramdom_number = 16384 * extract_number ;
double Lots_bis          =  0.1* extract_number;





   if(Bars<100)
     {
      Print("bars less than 100");
      return;
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return;
     }

  
  
  
   //***************INCLUDE*******INCLUDE******************** 
   //***************INCLUDE*******INCLUDE******************** 
  // #include <var_my_variable_bis.mqh>
  
  
   double MacdCurrent,MacdPrevious;
   double SignalCurrent,SignalPrevious;
   double MaCurrent,MaPrevious;
   int    cnt,ticket,total;


//--- to simplify the coding and speed up access data are put into internal variables
   MacdCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   MaCurrent=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   




     double sto7_m1 = iStochastic(NULL,PERIOD_M1, 7, 2, 3, MODE_EMA, 0, MODE_MAIN,  0);
     double sto7s_m1 = iStochastic(NULL,PERIOD_M1, 7, 2, 3, MODE_EMA, 0, MODE_SIGNAL,  0);
    
   
     
     double sto7_m5 = iStochastic(NULL,PERIOD_M5, 7, 2, 3, MODE_EMA, 0, MODE_MAIN,  0);
     double sto7s_m5 = iStochastic(NULL,PERIOD_M5, 7, 2, 3, MODE_EMA, 0, MODE_SIGNAL,  0);
    
   
     double sto7_m15 = iStochastic(NULL,PERIOD_M15, 7, 2, 3, MODE_EMA, 0, MODE_MAIN,  0);
     double sto7s_m15 = iStochastic(NULL,PERIOD_M15, 7, 2, 3, MODE_EMA, 0, MODE_SIGNAL,  0);
     
     double ma5_m1 = iMA(NULL, 1, 5, 0, MODE_EMA, PRICE_CLOSE,  0);
     double ma5_m5 = iMA(NULL, 5, 5, 0, MODE_EMA, PRICE_CLOSE,  0);
     double ma10_m1 = iMA(NULL, 1, 10, 0, MODE_EMA, PRICE_CLOSE,  0);
     double ma10_m5 = iMA(NULL, 5, 10, 0, MODE_EMA, PRICE_CLOSE,  0);
    
     int ea_profit = AccountProfit();
  
   //***************END INCLUDE*******INCLUDE******************** 
   //***************END INCLUDE*******INCLUDE******************** 
   
   
 

   total=OrdersTotal();
   int profit = OrderProfit();
   
   
   if(total<1)
     {
      //--- no opened orders identified
      if(AccountFreeMargin()<(1000*Lots_bis))
        {
         Print("We have no money. Free Margin = ",AccountFreeMargin());
         return;
        }
      //--- check for long position (BUY) possibility
      if(
      
      
      //*****************
    // #include <var_my_forbuy_bis.mqh>
     
     sto7_m5 > sto7s_m5
     //****************
   
         )
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots_bis,Ask,3,0,Ask+TakeProfit*Point,identity,ramdom_number,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("BUY order opened : ",OrderOpenPrice());
           }
         else
            Print("Error opening BUY order : ",GetLastError());
         return;
        }
      //--- check for short position (SELL) possibility
      if(
      
      //****************
     // #include <var_my_forsell_bis.mqh>
      sto7_m5 < sto7s_m5
      //*********************
    
         )
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots_bis,Bid,3,0,Bid-TakeProfit*Point,identity,ramdom_number,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("SELL order opened : ",OrderOpenPrice());
           }
         else
            Print("Error opening SELL order : ",GetLastError());
        }
      //--- exit from the "no opened orders" block
      return;
     }
//--- it is important to enter the market correctly, but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         //--- long position is opened
         if(OrderType()==OP_BUY)
           {
            //--- should it be closed?
            if(
            
             //************************************
             //#include <var_my_a_bis.mqh>
             sto7_m5 <= sto7s_m5
             
             //*************************************
            
            
            
         
               )
              {
               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet))
                  Print("OrderClose error ",GetLastError());
               return;
              }
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           }
         else // go to short position
           {
            //--- should it be closed?
            if(
            
           //***************************
            //#include <var_my_b_bis.mqh>  
            sto7_m5 >= sto7s_m5
            
            //*************************
          
               )
              {
               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet))
                  Print("OrderClose error ",GetLastError());
               return;
              }
            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red))
                        Print("OrderModify error ",GetLastError());
                     return;
                    }
                 }
              }
           }
        }
     }
//---
  }
//+------------------------------------------------------------------+
